import * as t from '@babel/types';
import { BindingBuilder } from './binding-builder';
import { AttributeValueFormatter } from '../helpers';
export interface ComponentBuilderOptions {
    moduleRelativePath: string;
    platform: string;
    attributeValueFormatter: AttributeValueFormatter;
    useDataBinding: boolean;
}
export declare class ComponentBuilder {
    private openTags;
    private pathsToResolve;
    private activeNamespaces;
    private usedNSTags;
    private options;
    private componentName;
    private moduleDirPath;
    private bindingBuilder;
    /**
     * Keep counter for the case of platform tags being inside platform tags.
     */
    private unsupportedPlatformTagCount;
    private treeIndex;
    private isComponentInitialized;
    private isInSlotFallbackScope;
    private moduleAst;
    private astBindingCallbacksBody;
    private astConstructorBody;
    private astCustomModulesRegister;
    constructor(options: ComponentBuilderOptions);
    setBindingBuilder(bindingBuilder: BindingBuilder): void;
    handleOpenTag(tagName: string, attributes: any): void;
    handleCloseTag(tagName: string): void;
    getModuleAst(): t.Program;
    getPathsToResolve(): string[];
    private assembleAst;
    private isClosingTag;
    private checkOpenTagNestingConditions;
    private handleViewProperties;
    private traverseAttributes;
    private getViewPropertySetterAst;
    private buildComponentAst;
    private generateComponentInitializationAstBody;
    private generateScriptAndStyleBindingAst;
    private generateBindingSourceAstCallback;
    private generateBindingCallbackDeclarations;
    private generateBindingTargetAstCallback;
    private registerNamespaces;
    private getLocalAndPrefixByName;
    private getResolvedPath;
    private isViewProperty;
}
